var express = require('express')
var app = express()
var server = require('http').Server(app)
var io = require('socket.io')(server) 
var cylon = require('cylon')
var m = require('mraa'); //Intel's IO Library


app.use(express.static(__dirname + '/public')) //look in the public folder for the static html file
server.listen(8080) //port to listen on

var analogValue = 0; 

board.on("ready", function() {
// this will be called when Cylon is fully initialized, which is when we should open up our WebSocket connection.
var cylonReady = function(my) {
io
.on('connection', function (socket) {
registerSocketHandlers(my, socket);
})
}
// set up hardware using Cylon
cylon.robot({
connections: {
edison: { adaptor: 'intel-iot' }
},
devices: {
button0: { driver: 'button', pin: 2 },
button1: { driver: 'button', pin: 3 },
button2: { driver: 'button', pin: 4 },
button3: { driver: 'button', pin: 5 },
sensor0: {
      driver: 'analogSensor',
     pin: 0,
     upperLimit: 900,
     lowerLimit: 100
    },
sensor1: {
      driver: 'analogSensor',
      pin: 1,
      upperLimit: 900,
      lowerLimit: 100
    },
sensor2: {
      driver: 'analogSensor',
      pin: 2,
      upperLimit: 900,
      lowerLimit: 100
    },
sensor3: {
      driver: 'analogSensor',
      pin: 3,
      upperLimit: 900,
      lowerLimit: 100
    },
}
}).on('ready', cylonReady);
cylon.start()


//register and emit button events when pushed and released
var registerSocketHandlers = function(my, socket) {
my.button0.on('push', function() {
socket.emit('button0', 'push')
})
my.button0.on('release', function() {
socket.emit('button0', 'release')
})

my.button1.on('push', function() {
socket.emit('button1', 'push')
})
my.button1.on('release', function() {
socket.emit('button1', 'release')
})

my.button2.on('push', function() {
socket.emit('button2', 'push')
})
my.button2.on('release', function() {
socket.emit('button2', 'release')
})

my.button3.on('push', function() {
socket.emit('button3', 'push')
})
my.button3.on('release', function() {
socket.emit('button3', 'release')
})

//read analog sensors and emit them through the open socket
    every((.1).second(), function() {
      analogValue = my.sensor0.analogRead();
      console.log('Analog0 value => ', analogValue);
      socket.emit('analog0', analogValue);
    });

      every((.1).second(), function() {
      analogValue = my.sensor1.analogRead();
      console.log('Analog1 value => ', analogValue);
      socket.emit('analog1', analogValue);
    });

        every((.1).second(), function() {
      analogValue = my.sensor2.analogRead();
      console.log('Analog2 value => ', analogValue);
      socket.emit('analog2', analogValue);
    });

          every((.1).second(), function() {
      analogValue = my.sensor3.analogRead();
      console.log('Analog3 value => ', analogValue);
      socket.emit('analog3', analogValue);
    });

   }
  
});
                                  

